Merge pull request #2247 from ivmai/match-ext-libgc-api
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = assemblyresolve gc-descriptors
2
3 check-local: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test-cattr-type-load test-reflection-load-with-context test_platform test-process-exit test-messages test-env-options test-unhandled-exception-2 test-appdomain-unload rm-empty-logs
4 check-full: test-sgen check-local
5 check-parallel: compile-tests check-full
6
7 check-coreclr:
8         $(MAKE) -C $(mono_build_root)/acceptance-tests check-coreclr
9
10 # for backwards compatibility on Wrench
11 test-wrench: check-parallel
12
13 aotcheck: testaot gshared-aot
14
15 TEST_PROG = ../interpreter/mint
16
17 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
18
19 TEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
20 JITTEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
21
22 RUNTIME_ARGS=--config tests-config --optimize=all --debug
23
24 CLASS=$(mcs_topdir)/class/lib/$(DEFAULT_PROFILE)
25
26 with_mono_path = MONO_PATH=$(CLASS)
27
28 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
29
30 MKBUNDLE = \
31         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
32         $(RUNTIME) $(CLASS)/mkbundle.exe
33
34 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -debug \
35         -nowarn:0162 -nowarn:0168 -nowarn:0219 -nowarn:0414 -nowarn:0618 \
36         -nowarn:0169 -nowarn:1690 -nowarn:0649 -nowarn:0612 -nowarn:3021 \
37         -nowarn:0197
38 ILASM = $(RUNTIME) $(CLASS)/ilasm.exe
39
40 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
41
42 STRESS_TESTS_SRC=       \
43         abort-stress-1.cs       \
44         abort-stress-2.cs       \
45         abort-stress-3.cs       \
46         domain-stress.cs        \
47         gchandle-stress.cs      \
48         monitor-stress.cs       \
49         thread-stress.cs        \
50         gc-stress.cs            \
51         gc-copy-stress.cs       \
52         gc-graystack-stress.cs          \
53         exit-stress.cs          \
54         process-stress.cs       \
55         assembly-load-stress.cs
56
57 # Disabled until ?mcs is fixed
58 #       bug-331958.cs
59 BASE_TEST_CS_SRC=               \
60         bug-2907.cs             \
61         array-init.cs           \
62         arraylist.cs            \
63         assemblyresolve_event.cs        \
64         assemblyresolve_event3.cs       \
65         assemblyresolve_event4.cs       \
66         checked.cs              \
67         char-isnumber.cs        \
68         create-instance.cs      \
69         field-layout.cs         \
70         pack-layout.cs          \
71         pack-bug.cs             \
72         hash-table.cs           \
73         test-ops.cs             \
74         obj.cs                  \
75         test-dup-mp.cs          \
76         string.cs               \
77         stringbuilder.cs        \
78         switch.cs               \
79         outparm.cs              \
80         delegate.cs             \
81         bitconverter.cs         \
82         exception.cs            \
83         exception2.cs           \
84         exception3.cs           \
85         exception4.cs           \
86         exception5.cs           \
87         exception6.cs           \
88         exception7.cs           \
89         exception8.cs           \
90         exception10.cs          \
91         exception11.cs          \
92         exception12.cs          \
93         exception13.cs          \
94         exception14.cs          \
95         exception15.cs          \
96         exception16.cs          \
97         exception17.cs          \
98         exception18.cs          \
99         typeload-unaligned.cs   \
100         struct.cs               \
101         valuetype-gettype.cs    \
102         typeof-ptr.cs           \
103         static-constructor.cs   \
104         pinvoke.cs              \
105         pinvoke2.cs             \
106         pinvoke3.cs             \
107         pinvoke11.cs            \
108         pinvoke13.cs            \
109         pinvoke17.cs            \
110         invoke.cs               \
111         invoke2.cs              \
112         runtime-invoke.cs               \
113         invoke-string-ctors.cs          \
114         reinit.cs               \
115         box.cs                  \
116         array.cs                \
117         enum.cs                 \
118         enum2.cs                \
119         enum-intrins.cs         \
120         property.cs             \
121         enumcast.cs             \
122         assignable-tests.cs     \
123         array-cast.cs           \
124         array-subtype-attr.cs   \
125         cattr-compile.cs        \
126         cattr-field.cs          \
127         cattr-object.cs         \
128         custom-attr.cs          \
129         double-cast.cs          \
130         newobj-valuetype.cs     \
131         arraylist-clone.cs      \
132         setenv.cs               \
133         vtype.cs                \
134         isvaluetype.cs          \
135         iface6.cs               \
136         iface7.cs               \
137         ipaddress.cs            \
138         array-vt.cs             \
139         interface1.cs           \
140         reflection-enum.cs      \
141         reflection-prop.cs      \
142         reflection4.cs          \
143         reflection5.cs          \
144         reflection-const-field.cs \
145         many-locals.cs          \
146         string-compare.cs       \
147         test-prime.cs           \
148         test-tls.cs             \
149         params.cs               \
150         reflection.cs           \
151         interface.cs            \
152         iface.cs                \
153         iface2.cs               \
154         iface3.cs               \
155         iface4.cs               \
156         iface-large.cs          \
157         virtual-method.cs       \
158         intptrcast.cs           \
159         indexer.cs              \
160         stream.cs               \
161         console.cs              \
162         shift.cs                \
163         jit-int.cs              \
164         jit-uint.cs             \
165         jit-long.cs             \
166         long.cs                 \
167         jit-ulong.cs            \
168         jit-float.cs            \
169         pop.cs                  \
170         time.cs                 \
171         appdomain.cs        \
172         appdomain1.cs           \
173         appdomain2.cs           \
174         appdomain-client.cs     \
175         appdomain-unload.cs \
176         appdomain-async-invoke.cs       \
177         loader.cs       \
178         pointer.cs              \
179         hashcode.cs             \
180         delegate1.cs            \
181         delegate2.cs            \
182         delegate3.cs            \
183         delegate5.cs            \
184         delegate6.cs            \
185         delegate7.cs            \
186         delegate8.cs            \
187         delegate9.cs            \
188         delegate10.cs           \
189         delegate11.cs           \
190         delegate12.cs           \
191         remoting1.cs            \
192         remoting2.cs            \
193         remoting3.cs            \
194         remoting4.cs            \
195         remoting5.cs            \
196         largeexp.cs             \
197         largeexp2.cs            \
198         marshalbyref1.cs        \
199         static-ctor.cs          \
200         inctest.cs              \
201         bound.cs                \
202         array-invoke.cs         \
203         test-arr.cs             \
204         decimal.cs              \
205         decimal-array.cs        \
206         marshal.cs              \
207         marshal1.cs             \
208         marshal2.cs             \
209         marshal3.cs             \
210         marshal5.cs             \
211         marshal6.cs             \
212         marshal7.cs             \
213         marshal8.cs             \
214         marshal9.cs             \
215         marshalbool.cs          \
216         marshal-valuetypes.cs   \
217         test-byval-in-struct.cs \
218         thread.cs               \
219         thread5.cs              \
220         thread6.cs              \
221         thread-static.cs        \
222         thread-static-init.cs   \
223         context-static.cs       \
224         float-pop.cs            \
225         interfacecast.cs        \
226         array3.cs               \
227         classinit.cs            \
228         classinit2.cs           \
229         classinit3.cs           \
230         synchronized.cs         \
231         async_read.cs           \
232         threadpool.cs           \
233         threadpool1.cs          \
234         threadpool-exceptions1.cs \
235         threadpool-exceptions2.cs \
236         threadpool-exceptions3.cs \
237         threadpool-exceptions4.cs \
238         threadpool-exceptions5.cs \
239         threadpool-exceptions6.cs \
240         threadpool-exceptions7.cs \
241         base-definition.cs      \
242         bug-27420.cs            \
243         bug-47295.cs            \
244         bug-46781.cs            \
245         bug-48015.cs            \
246         bug-42136.cs            \
247         bug-59286.cs            \
248         bug-70561.cs            \
249         bug-78311.cs            \
250         bug-78653.cs            \
251         bug-78656.cs            \
252         bug-77127.cs            \
253         bug-323114.cs           \
254         bug-Xamarin-5278.cs     \
255         interlocked.cs          \
256         cross-domain.cs         \
257         appdomain-exit.cs       \
258         delegate-async-exit.cs  \
259         delegate-delegate-exit.cs       \
260         delegate-exit.cs        \
261         finalizer-abort.cs      \
262         finalizer-exception.cs  \
263         finalizer-exit.cs       \
264         finalizer-thread.cs     \
265         main-exit.cs    \
266         main-returns-abort-resetabort.cs        \
267         main-returns-background-abort-resetabort.cs     \
268         main-returns-background-resetabort.cs   \
269         main-returns-background.cs      \
270         main-returns-background-change.cs       \
271         main-returns.cs         \
272         subthread-exit.cs       \
273         desweak.cs              \
274         cominterop.cs           \
275         exists.cs               \
276         handleref.cs    \
277         transparentproxy.cs \
278         dbnull-missing.cs       \
279         test-type-ctor.cs       \
280         soft-float-tests.cs     \
281         thread-exit.cs          \
282         finalize-parent.cs      \
283         assemblyresolve_event2.2.cs     \
284         interlocked-2.2.cs      \
285         pinvoke-2.2.cs          \
286         bug-78431.2.cs          \
287         bug-79684.2.cs          \
288         catch-generics.2.cs     \
289         event-get.2.cs          \
290         safehandle.2.cs         \
291         stackframes-async.2.cs          \
292         module-cctor-loader.2.cs        \
293         generics-invoke-byref.2.cs      \
294         generic-signature-compare.2.cs  \
295         generics-sharing.2.cs   \
296         shared-generic-methods.2.cs     \
297         shared-generic-synchronized.2.cs        \
298         generic-inlining.2.cs   \
299         generic-initobj.2.cs    \
300         generic-delegate.2.cs   \
301         generic-sizeof.2.cs     \
302         generic-virtual.2.cs    \
303         generic-interface-methods.2.cs  \
304         generic-array-type.2.cs \
305         generic-method-patching.2.cs    \
306         generic-static-methods.2.cs     \
307         generic-null-call.2.cs  \
308         generic-special.2.cs    \
309         generic-exceptions.2.cs \
310         generic-virtual2.2.cs   \
311         generic-valuetype-interface.2.cs        \
312         generic-getgenericarguments.2.cs        \
313         generic-type-builder.2.cs       \
314         generic-synchronized.2.cs       \
315         generic-delegate-ctor.2.cs      \
316         generic-array-iface-set.2.cs    \
317         generic-typedef.2.cs    \
318         generic-marshalbyref.2.cs       \
319         generic-xdomain.2.cs    \
320         dynamic-generic-size.cs \
321         bug-431413.2.cs \
322         bug-459285.2.cs \
323         generic-virtual-invoke.2.cs     \
324         bug-461198.2.cs \
325         generic-sealed-virtual.2.cs     \
326         generic-system-arrays.2.cs      \
327         generic-stack-traces.2.cs       \
328         generic-stack-traces2.2.cs      \
329         bug-472600.2.cs \
330         recursive-generics.2.cs \
331         bug-473482.2.cs \
332         bug-473999.2.cs \
333         bug-479763.2.cs \
334         bug-616463.cs   \
335         bug-80392.2.cs          \
336         dynamic-method-access.2.cs      \
337         dynamic-method-finalize.2.cs    \
338         dynamic-method-stack-traces.cs  \
339         bug-82194.2.cs  \
340         anonarray.2.cs  \
341         ienumerator-interfaces.2.cs     \
342         array-enumerator-ifaces.2.cs    \
343         generic_type_definition_encoding.2.cs \
344         generic_type_definition.2.cs    \
345         bug-333798.2.cs         \
346         bug-333798-tb.2.cs              \
347         bug-335131.2.cs         \
348         bug-322722_patch_bx.2.cs                \
349         bug-348522.2.cs         \
350         bug-340662_bug.cs       \
351         bug-322722_dyn_method_throw.2.cs        \
352         bug-389886-2.cs \
353         bug-325283.2.cs \
354         thunks.cs \
355         winx64structs.cs \
356         bug-349190.2.cs \
357         nullable_boxing.2.cs    \
358         valuetype-equals.cs     \
359         custom-modifiers.2.cs   \
360         bug-382986.cs   \
361         test-inline-call-stack.cs       \
362         bug-324535.cs   \
363         modules.cs      \
364         bug-81673.cs    \
365         bug-81691.cs    \
366         bug-80307.cs    \
367         bug-415577.cs   \
368         filter-stack.cs \
369         vararg2.cs      \
370         bug-389886-sre-generic-interface-instances.cs   \
371         bug-461867.cs   \
372         bug-461941.cs   \
373         bug-461261.cs   \
374         bug-400716.cs   \
375         bug-462592.cs   \
376         bug-459094.cs   \
377         generic-unloading.2.cs  \
378         generic-unloading-sub.2.cs      \
379         bug-467456.cs   \
380         appdomain-unload-callback.cs    \
381         bug-508538.cs   \
382         bug-472692.2.cs         \
383         gchandles.cs    \
384         interlocked-3.cs        \
385         interlocked-4.2.cs      \
386         appdomain-thread-abort.cs \
387         xdomain-threads.cs      \
388         w32message.cs   \
389         bug-544446.cs   \
390         gc-altstack.cs  \
391         large-gc-bitmap.cs      \
392         bug-561239.cs   \
393         bug-562150.cs   \
394         bug-575941.cs   \
395         bug-599469.cs   \
396         bug-389886-3.cs \
397         monitor.cs      \
398         monitor-resurrection.cs \
399         dynamic-method-resurrection.cs  \
400         bug-666008.cs   \
401         bug-685908.cs   \
402         sgen-long-vtype.cs      \
403         delegate-invoke.cs      \
404         bug-696593.cs   \
405         bug-705140.cs   \
406         bug-1147.cs     \
407         mono-path.cs    \
408         bug-bxc-795.cs  \
409         bug-3903.cs     \
410         async-with-cb-throws.cs \
411         appdomain-unload-doesnot-raise-pending-events.cs        \
412         bug-6148.cs     \
413         assembly_append_ordering.cs     \
414         bug-10127.cs    \
415         bug-18026.cs    \
416         allow-synchronous-major.cs      \
417         unload-appdomain-on-shutdown.cs \
418         block_guard_restore_aligment_on_exit.cs \
419         thread_static_gc_layout.cs \
420         sleep.cs \
421         bug-27147.cs    \
422         bug-30085.cs    \
423         bug-17537.cs    \
424         pinvoke_ppcc.cs \
425         pinvoke_ppcs.cs \
426         pinvoke_ppci.cs \
427         pinvoke_ppcf.cs \
428         pinvoke_ppcd.cs
429
430 TEST_CS_SRC_DIST=       \
431         $(BASE_TEST_CS_SRC)     \
432         async-exc-compilation.cs \
433         filter-stack.cs \
434         finally_guard.cs \
435         finally_block_ending_in_dead_bb.cs
436
437 TEST_CS_SRC_GEN = \
438         runtime-invoke.gen.cs \
439         imt_big_iface_test.cs
440
441 if AMD64
442 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
443 # #651684
444 PLATFORM_DISABLED_TESTS = finally_guard.exe
445 else
446 if X86
447 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
448 else
449 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
450 endif
451 endif
452
453 if IA64
454 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
455 # bug #319249
456 PLATFORM_DISABLED_TESTS=exception17.exe
457 PLATFORM_DISABLED_TESTS+=winx64structs.exe
458 endif
459
460 if X86
461
462 if HOST_WIN32
463 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe finally_block_ending_in_dead_bb.exe \
464         bug-18026.exe monitor.exe threadpool-exceptions5.exe
465 endif
466
467 endif
468
469 if POWERPC
470 # bug #71274
471 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
472 endif
473
474 if POWERPC64
475 # FIXME: These tests hang/fail for unknown reasons
476 PLATFORM_DISABLED_TESTS=monitor.exe threadpool-exceptions5.exe
477 endif
478
479 if ARM
480 PLATFORM_DISABLED_TESTS=filter-stack.exe
481 endif
482
483 if MIPS
484 # monitor.exe is racy
485 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
486 endif
487
488 if S390X
489 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
490 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
491 endif
492
493 if NACL_CODEGEN
494 # Tests that use Thread.Abort()
495 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
496                          abort-stress-2.exe \
497                          abort-stress-3.exe \
498                          appdomain-thread-abort.exe \
499                          async-exc-compilation.exe \
500                          bug-561239.exe \
501                          bug-70561.exe \
502                          finalizer-abort.exe \
503                          finally_guard.exe \
504                          finally_block_ending_in_dead_bb.exe \
505                          main-returns-abort-resetabort.exe \
506                          main-returns-background-abort-resetabort.exe \
507                          thread6.exe \
508                          threadpool-exceptions5.exe \
509                          threadpool-exceptions6.exe
510
511 # Tests that rely on AppDomain.Unload
512 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
513                           appdomain-exit.exe \
514                           appdomain-unload-callback.exe \
515                           appdomain-unload.exe \
516                           domain-stress.exe \
517                           generic-unloading.2.exe \
518                           monitor.exe \
519                           remoting4.exe \
520                           threadpool-exceptions7.exe \
521                           xdomain-threads.exe
522
523 # pinvoke2 attaches a thread to the runtime, but
524 # doesn't 'unattach' it and it hangs in GC on exit
525 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
526
527 # Tests that currently hang waiting for non-main threads
528 # to exit in NaCl, need to investigate.  Most are AppDomain
529 # creation and Delegate tests.
530 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
531                           delegate9.exe \
532                           marshal-valuetypes.exe \
533                           cross-domain.exe \
534                           stackframes-async.2.exe \
535                           generic-marshalbyref.2.exe \
536                           generic-xdomain.2.exe \
537                           bug-415577.exe
538
539 # Tests that fail trying to write files (appdomain create mostly)
540 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
541                           bug-349190.2.exe \
542                           bug-80307.exe \
543                           bug-462592.exe
544
545 # FIXME: don't know why delegate2.exe fails, it shouldn't
546 PLATFORM_DISABLED_TESTS+= delegate2.exe
547
548 # These tests newly fail with the latest revision. pinvoke3 fails because
549 # of a thread attach, the others have not been investigated.  TODO revisit.
550 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
551                           async_read.exe \
552                           async-with-cb-throws.exe \
553                           appdomain-unload-doesnot-raise-pending-events.exe \
554                           gsharing-valuetype-layout.exe
555
556 if X86
557 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
558 PLATFORM_DISABLED_TESTS+= delegate1.exe \
559                           delegate3.exe \
560                           delegate5.exe \
561                           delegate8.exe \
562                           threadpool.exe \
563                           threadpool1.exe \
564                           threadpool-exceptions3.exe \
565                           bug-323114.exe \
566                           delegate-exit.exe \
567                           bug-80392.2.exe
568
569 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
570 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
571                           main-returns-background.exe \
572                           main-returns-background-change.exe
573 endif
574
575 endif
576
577 # The two finalizer tests only work under sgen
578 # gc-altstack.exe fails under boehm because it has no support for altstack
579 # bug-459094.exe creates an extremely deep directory tree
580 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
581 # reverted.
582 # bug-Xamarin-5278.exe got broken by 5d26590e79da139a284459299aee95c25f4cd835
583 DISABLED_TESTS=                 \
584         delegate-async-exception.exe    \
585         bug-348522.2.exe        \
586         bug-459094.exe \
587         delegate-invoke.exe \
588         bug-Xamarin-5278.exe \
589         $(PLATFORM_DISABLED_TESTS) \
590         $(EXTRA_DISABLED_TESTS)
591
592 DISABLED_TESTS_WRENCH=  \
593         $(DISABLED_TESTS)       \
594         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
595         main-returns-background-resetabort.exe \
596         main-returns-background-abort-resetabort.exe    \
597         thread6.exe     \
598         assemblyresolve_event3.exe \
599         delegate2.exe   \
600         finally_guard.exe \
601         gc-altstack.exe \
602         generic-xdomain.2.exe
603
604 AOT_DISABLED_TESTS=constraints-load.exe
605
606 # These only compile with MS CSC
607 TEST_CSC_SRC=                   \
608         vararg.cs
609
610 TEST_IL_SRC=                    \
611         field-access.il         \
612         method-access.il        \
613         ldftn-access.il         \
614         cpblkTest.il            \
615         vbinterface.il          \
616         calliTest.il            \
617         calliGenericTest.il             \
618         ckfiniteTest.il         \
619         fault-handler.il                \
620         locallocTest.il         \
621         initblkTest.il          \
622         qt-instance.il          \
623         vararg.il               \
624         bug-29859.il            \
625         bug-78549.il            \
626         static-fields-nonconst.il       \
627         reload-at-bb-end.il     \
628         test-enum-indstoreil.il \
629         filter-bug.il           \
630         even-odd.il             \
631         bug-82022.il    \
632         vt-sync-method.il       \
633         enum_types.il   \
634         invalid-token.il        \
635         call_missing_method.il  \
636         call_missing_class.il   \
637         ldfld_missing_field.il  \
638         ldfld_missing_class.il  \
639         find-method.2.il        \
640         bug-79215.2.il  \
641         bug-79956.2.il  \
642         bug-327438.2.il \
643         bug-387274.2.il \
644         bug-426309.2.il \
645         ldtoken_with_byref_typespec.2.il \
646         resolve_method_bug.2.il \
647         resolve_field_bug.2.il \
648         resolve_type_bug.2.il   \
649         generics-sharing-other-exc.2.il \
650         generic-ldobj.2.il      \
651         generic-mkrefany.2.il   \
652         generic-refanyval.2.il  \
653         generic-ldtoken.2.il    \
654         generic-ldtoken-method.2.il     \
655         generic-ldtoken-field.2.il      \
656         generic-tailcall.2.il   \
657         generic-tailcall2.2.il  \
658         generic-array-exc.2.il  \
659         generic-valuetype-newobj2.2.il  \
660         generic-valuetype-newobj.2.il   \
661         generic-constrained.2.il        \
662         generic-type-load-exception.2.il        \
663         bug-81466.il    \
664         bug457574.il    \
665         bug445361.il    \
666         bug-463303.il   \
667         bug469742.2.il  \
668         bug-528055.il   \
669         constraints-load.il     \
670         array_load_exception.il \
671         bug-481403.il   \
672         interface-with-static-method.il \
673         bug-515884.il   \
674         bug-633291.il   \
675         delegate-with-null-target.il    \
676         bug-318677.il   \
677         gsharing-valuetype-layout.il    \
678         invalid_generic_instantiation.il
679
680
681 # pre-requisite test sources: files that are not test themselves
682 # but that need to be compiled
683 PREREQ_IL_SRC=event-il.il module-cctor.il
684 PREREQ_CS_SRC=
685 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
686 PREREQ_CS_DLL_SRC=
687
688 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
689 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
690 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
691 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
692 TESTBS=$(BENCHSRC:.cs=.exe)
693 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
694
695 EXTRA_DIST=test-driver test-runner.cs $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
696         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
697
698 %.exe: %.il
699         $(ILASM) -out:$@ $<
700
701 %.exe: %.cs TestDriver.dll
702         $(MCS) -r:TestDriver.dll -out:$@ $<
703
704 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
705 if POWERPC
706 test_platform:
707 else
708 # Can't use mkbundle on win32 since there is no static build there
709 # Can't run test-unhandled-exception on Windows because of all the debug popups...
710 if HOST_WIN32
711 test_platform:
712 else
713 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
714 #test_platform: testbundle test-iomap-regression
715 test_platform:  test-iomap-regression
716 endif
717 endif
718
719 if X86
720 if HOST_WIN32
721 else
722 test_platform: test-eglib-remap
723 endif
724 endif
725
726 # Target to precompile the test executables
727 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
728
729 #
730 # Test that no symbols are missed in eglib-remap.h
731 #
732 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file\|g_Ctoc\'
733 if NACL_CODEGEN
734 test-eglib-remap:
735 else
736 test-eglib-remap:
737         @echo "Testing eglib remap..."
738         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
739 endif
740
741 #
742 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
743 # code that checks that the table is properly sorted
744 #
745 if NACL_CODEGEN
746 test-messages:
747 else
748 if HOST_WIN32
749 test-messages:
750 else
751 test-messages: w32message.exe
752         > test_messages.zero
753         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe > w32message.allout 2>&1 && cmp test_messages.zero w32message.allout
754 endif
755 endif
756
757 test-env-options:
758         MONO_ENV_OPTIONS="--version" $(RUNTIME) array-init.exe | grep -q Architecture:
759
760 if AMD64
761 test-sgen : sgen-tests
762 else
763 if X86
764 if HOST_WIN32
765 test-sgen :
766 else
767 test-sgen : sgen-tests
768 endif
769 else
770 if ARM
771 test-sgen : sgen-tests
772 else
773 if S390X
774 test-sgen : sgen-regular-tests
775 endif
776 endif
777 endif
778 endif
779
780 # Precompile the test assemblies in parallel
781 compile-tests:
782         $(MAKE) -j4 $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
783
784 # Remove empty .stdout and .stderr files for wrench
785 rm-empty-logs:
786         @echo "Removing empty logs..."
787         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
788
789 assemblyresolve/test/asm.dll:
790         $(MAKE) -C assemblyresolve prereq
791
792 TestDriver.dll:
793         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
794
795 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
796         @failed=0; \
797         passed=0; \
798         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
799         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
800         for i in $(TESTSI_CS); do       \
801                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
802                 then \
803                         passed=`expr $${passed} + 1`; \
804                 else \
805                         if [ $$? = 2 ]; then break; fi; \
806                         failed=`expr $${failed} + 1`; \
807                 fi \
808         done; \
809         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
810
811 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
812         @failed=0; \
813         passed=0; \
814         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
815         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
816         for i in $(TESTSI_IL); do       \
817                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
818                 then \
819                         passed=`expr $${passed} + 1`; \
820                 else \
821                         if [ $$? = 2 ]; then break; fi; \
822                         failed=`expr $${failed} + 1`; \
823                 fi \
824         done; \
825         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
826
827 testb: $(TEST_PROG) $(TESTBS)
828         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
829         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
830         for i in $(TESTBS); do  \
831                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS);  \
832         done
833
834 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
835         @failed=0; \
836         passed=0; \
837         failed_tests="";\
838         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
839         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
840         rm -f testlist testlist.sorted; \
841         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do echo $${i} >> testlist; sort testlist > testlist.sorted; done; \
842         for i in `cat testlist.sorted`; do \
843                 rm -f $${i}.so; \
844                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
845                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
846                 then \
847                         passed=`expr $${passed} + 1`; \
848                 else \
849                         if [ $$? = 2 ]; then break; fi; \
850                         failed=`expr $${failed} + 1`; \
851                         failed_tests="$${failed_tests} $$i"; \
852                 fi \
853         done; \
854         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
855         rm -f testlist testlist.sorted; \
856         if [ $${failed} != 0 ]; then \
857           echo -e "\nFailed tests:\n"; \
858           for i in $${failed_tests}; do \
859             echo $${i}; \
860             if [ "x$$V" = "x1" ]; then \
861               cat $${i}.stdout; \
862               cat $${i}.stderr; \
863             fi; \
864           done; \
865           exit 1; \
866         fi
867
868 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
869         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
870         $(RUNTIME) ./test-runner.exe -j a --testsuite-name "runtime" --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
871
872 runtest-managed-serial: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
873         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
874         $(RUNTIME) ./test-runner.exe -j 1 --testsuite-name "runtime" --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
875
876 testjit:
877         @if test x$(M) != x0; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
878
879 testaot:
880         @$(MAKE) AOT=1 runtest
881
882 testtrace:
883         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
884
885 testinterp:
886         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
887
888 testjitspeed: $(JITTEST_PROG) $(TESTBS)
889         for i in $(TESTBS); do  \
890                 echo $$i;       \
891                 time $(JITTEST_PROG) $$i;       \
892         done
893
894 test-iomap-regression: exists.cs
895         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
896         @echo "Testing exists.exe..."
897         @MONO_IOMAP=all $(RUNTIME) exists.exe
898
899 stresstest: $(STRESS_TESTS)
900         @failed=0; \
901         passed=0; \
902         failed_tests="";\
903         for i in $(STRESS_TESTS); do    \
904                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
905                 then \
906                         passed=`expr $${passed} + 1`; \
907                 else \
908                         if [ $$? = 2 ]; then break; fi; \
909                         failed=`expr $${failed} + 1`; \
910                         failed_tests="$${failed_tests} $$i"; \
911                 fi \
912         done; \
913         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
914         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
915           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
916
917 testbundle: console.exe
918         @echo "Testing mkbundle..."
919         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
920         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) ./a.out >> mkbundle.stdout
921         @- rm -rf a.out
922
923 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
924 test-type-load: TestDriver.dll
925         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
926         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
927         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
928         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
929         @echo "Testing load-exception.exe..."
930         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
931
932 EXTRA_DIST += custom-attr-errors.cs custom-attr-errors-lib.cs
933 test-cattr-type-load: TestDriver.dll custom-attr-errors.cs custom-attr-errors-lib.cs
934         $(MCS) -D:WITH_MEMBERS /t:library $(srcdir)/custom-attr-errors-lib.cs
935         $(MCS) -r:TestDriver.dll -r:custom-attr-errors-lib.dll  $(srcdir)/custom-attr-errors.cs
936         $(MCS) /t:library $(srcdir)/custom-attr-errors-lib.cs
937         @echo "Testing custom-attribute-load-exceptions.exe..."
938         @$(RUNTIME) custom-attr-errors.exe > custom-attr-errors.exe.stdout 2> custom-attr-errors.exe.stderr
939
940 EXTRA_DIST += reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.cs
941 test-reflection-load-with-context: reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.exe
942         rm -rf reflection-load-dir
943         mkdir reflection-load-dir
944         $(MCS) /t:library $(srcdir)/reflection-load-with-context-second-lib.cs -out:reflection-load-dir/reflection-load-with-context-second-lib.dll
945         $(MCS) /t:library -r:reflection-load-dir/reflection-load-with-context-second-lib.dll $(srcdir)/reflection-load-with-context-lib.cs -out:reflection-load-dir/reflection-load-with-context-lib.dll
946         @echo "Testing reflection-load-with-context.cs.exe..."
947         @$(RUNTIME) reflection-load-with-context.exe > reflection-load-with-context.exe.stdout 2> reflection-load-with-context.exe.stderr
948
949
950 EXTRA_DIST += debug-casts.cs
951 # This depends on TLS, so its not ran by default
952 debug-casts:
953         @$(MCS) -r:TestDriver.dll $(srcdir)/debug-casts.cs
954         @$(RUNTIME) --debug=casts debug-casts.exe
955
956 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs sgen-domain-unload-2.cs sgen-suspend.cs sgen-new-threads-dont-join-stw.cs sgen-bridge-xref.cs bug-17590.cs sgen-toggleref.cs
957
958
959 #those are actually configurations, eg plain_sgen-descriptors.exe
960 #DISABLE_SGEN_TESTS =
961
962 SGEN_TESTS =    \
963         finalizer-wait.exe      \
964         critical-finalizers.exe \
965         sgen-descriptors.exe    \
966         sgen-gshared-vtype.exe  \
967         sgen-domain-unload.exe  \
968         sgen-domain-unload-2.exe        \
969         sgen-weakref-stress.exe \
970         sgen-cementing-stress.exe       \
971         sgen-case-23400.exe     \
972         sgen-new-threads-dont-join-stw.exe      \
973         gc-graystack-stress.exe \
974         bug-17590.exe
975
976 SGEN_CONFIGURATIONS =   \
977         "|plain"        \
978         "major=marksweep-conc|ms-conc"  \
979         "major=marksweep-conc,minor=split|ms-conc-split"        \
980         "minor=split|ms-split"  \
981         "minor=split,alloc-ratio=95|ms-split-95"        \
982         "|plain-clear-at-gc|clear-at-gc"        \
983         "major=marksweep-conc|ms-conc-clear-at-gc|clear-at-gc"  \
984         "minor=split|ms-split-clear-at-gc|clear-at-gc"
985
986
987 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
988 SGEN_BRIDGE_CONFIGURATIONS =    \
989         "|plain"        \
990         ",major=marksweep-conc|ms-conc" \
991         "minor=split|ms-split"  \
992         "bridge-implementation=new|plain-new-bridge"    \
993         "bridge-implementation=new,major=marksweep-conc|ms-conc-new-bridge"     \
994         "bridge-implementation=new,minor=split|ms-split-new-bridge"     \
995         "bridge-implementation=tarjan|plain-tarjan-bridge"      \
996         "bridge-implementation=tarjan,minor=split|ms-split-tarjan-bridge"
997
998 sgen-regular-tests: $(SGEN_TESTS)
999         @failed=0; \
1000         passed=0; \
1001         failed_tests="";\
1002         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1003         for test in $+; do      \
1004                 echo "...$$test";       \
1005                 for conf in $(SGEN_CONFIGURATIONS); do  \
1006                         name=`echo $$conf | cut -d\| -f 2`;     \
1007                         params=`echo $$conf | cut -d\| -f 1`;   \
1008                         debug_opt=`echo $$conf | cut -d\| -f 3`;        \
1009                         test_name="$${test}|$${name}";  \
1010                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" MONO_GC_DEBUG="$$debug_opt" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);     \
1011                         then \
1012                                 passed=`expr $${passed} + 1`; \
1013                         else \
1014                                 if [ $$? = 2 ]; then break; fi; \
1015                                 failed=`expr $${failed} + 1`; \
1016                                 failed_tests="$${failed_tests} $$test_name"; \
1017                         fi \
1018                 done    \
1019         done;   \
1020         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1021         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1022           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1023
1024 sgen-bridge-tests1: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
1025         @failed=0; \
1026         passed=0; \
1027         failed_tests="";\
1028         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1029         for test in $+; do      \
1030                 echo "...$$test";       \
1031                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1032                         name=`echo $$conf | cut -d\| -f 2`;     \
1033                         params=`echo $$conf | cut -d\| -f 1`;   \
1034                         test_name="$${test}|$${name}";  \
1035                         if MONO_GC_DEBUG="bridge=Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS); \
1036                         then \
1037                                 passed=`expr $${passed} + 1`; \
1038                         else \
1039                                 if [ $$? = 2 ]; then break; fi; \
1040                                 failed=`expr $${failed} + 1`; \
1041                                 failed_tests="$${failed_tests} $$test_name"; \
1042                         fi \
1043                 done    \
1044         done;   \
1045         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1046         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1047           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1048
1049 sgen-bridge-tests2: sgen-bridge-xref.exe
1050         @failed=0; \
1051         passed=0; \
1052         failed_tests="";\
1053         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1054         for test in $+; do      \
1055                 echo "...$$test";       \
1056                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1057                         name=`echo $$conf | cut -d\| -f 2`;     \
1058                         params=`echo $$conf | cut -d\| -f 1`;   \
1059                         test_name="$${test}|$${name}";  \
1060                         if MONO_GC_DEBUG="bridge=2Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);        \
1061                         then \
1062                                 passed=`expr $${passed} + 1`; \
1063                         else \
1064                                 if [ $$? = 2 ]; then break; fi; \
1065                                 failed=`expr $${failed} + 1`; \
1066                                 failed_tests="$${failed_tests} $$test_name"; \
1067                         fi \
1068                 done    \
1069         done;   \
1070         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1071         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1072           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1073
1074 sgen-toggleref-tests: sgen-toggleref.exe
1075         @failed=0; \
1076         passed=0; \
1077         failed_tests="";\
1078         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1079         for test in $+; do      \
1080                 echo "...$$test";       \
1081                 for conf in $(SGEN_CONFIGURATIONS); do  \
1082                         name=`echo $$conf | cut -d\| -f 2`;     \
1083                         params=`echo $$conf | cut -d\| -f 1`;   \
1084                         test_name="$${test}|$${name}";  \
1085                         if MONO_GC_PARAMS="toggleref-test,$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);  \
1086                         then \
1087                                 passed=`expr $${passed} + 1`; \
1088                         else \
1089                                 if [ $$? = 2 ]; then break; fi; \
1090                                 failed=`expr $${failed} + 1`; \
1091                                 failed_tests="$${failed_tests} $$test_name"; \
1092                         fi \
1093                 done    \
1094         done;   \
1095         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1096         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1097           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1098
1099 sgen-bridge-tests: sgen-bridge-tests1 sgen-bridge-tests2
1100
1101 sgen-tests: sgen-regular-tests sgen-bridge-tests sgen-toggleref-tests
1102
1103 AOT_CONFIGURATIONS=     \
1104         "|regular"      \
1105         "--gc=boehm|boehm"
1106
1107 #LLVM crashes, got to fix it first.
1108 #       "--llvm|llvm"   \
1109 #       "--llvm --gc=boehm|llvm+boehm"
1110
1111
1112 test-aot:
1113         @failed=0; \
1114         passed=0; \
1115         failed_tests="";\
1116         profile=$(DEFAULT_PROFILE);     \
1117         tmpfile=`mktemp -t mono_aot_output` || exit 1;  \
1118         rm -f test-aot-$${name}.stdout test-aot-$${name}.stderr; \
1119         for assembly in $(mcs_topdir)/class/lib/$$profile/*.dll ; do    \
1120                 asm_name=`basename $$assembly`; \
1121                 echo "... $$asm_name";  \
1122                 for conf in $(AOT_CONFIGURATIONS); do   \
1123                         name=`echo $$conf | cut -d\| -f 2`;     \
1124                         params=`echo $$conf | cut -d\| -f 1`;   \
1125                         test_name="$${asm_name}|$${name}";      \
1126                         echo "  $$test_name";   \
1127                         if MONO_PATH=$(mcs_topdir)/class/lib/$$profile $(JITTEST_PROG_RUN) $$params --aot=outfile=$$tmpfile $$assembly >> test-aot-$${name}.stdout 2>> test-aot-$${name}.stderr;        \
1128                         then \
1129                                 passed=`expr $${passed} + 1`; \
1130                         else \
1131                                 failed=`expr $${failed} + 1`; \
1132                                 failed_tests="$${failed_tests} $$test_name"; \
1133                         fi \
1134                 done;   \
1135         done;   \
1136         rm      $$tmpfile;      \
1137         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1138         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1139         for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1140
1141
1142 # Generated tests for runtime invoke
1143 EXTRA_DIST += gen-runtime-invoke.cs
1144 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
1145         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
1146         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
1147
1148 EXTRA_DIST += make-imt-test.cs
1149 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
1150         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
1151         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
1152
1153 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
1154 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
1155         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
1156 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
1157         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
1158
1159 EXTRA_DIST += unhandled-exception-base-configuration.config
1160 EXTRA_DIST += unhandled-exception-legacy-configuration.config
1161 EXTRA_DIST += appdomain-unload.exe.config
1162 EXTRA_DIST += unhandled-exception-test-case.2.cs
1163 EXTRA_DIST += unhandled-exception-test-runner.2.cs
1164 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
1165         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
1166 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
1167         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
1168 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
1169         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
1170 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
1171         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
1172         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
1173         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
1174         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
1175 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
1176         $(MCS) /debug unhandled-exception-test-case.1.cs
1177 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
1178         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1179 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1180         $(MCS) /debug unhandled-exception-test-case.2.cs
1181 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1182         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1183 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1184         $(MCS) /debug unhandled-exception-test-runner.2.cs
1185
1186 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1187         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1188
1189 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1190 bug-80307.exe: $(srcdir)/bug-80307.cs
1191         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1192         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1193
1194 EXTRA_DIST += bug-81673-interface.cs
1195 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1196         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1197         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1198         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1199
1200 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1201 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1202         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1203         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1204         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1205         rm -f bug-81691-a.dll
1206 bug-81691.exe: bug-81691-b.dll
1207
1208 EXTRA_DIST += bug-81466-lib.il
1209 bug-81466-lib.dll: bug-81466-lib.il
1210         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1211 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1212         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1213
1214 EXTRA_DIST += bug-324535-il.il
1215 bug-324535-il.dll : bug-324535-il.il
1216         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1217 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1218         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1219
1220 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1221 custom-modifiers-lib.dll: custom-modifiers-lib.il
1222         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1223 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1224         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1225
1226 EXTRA_DIST += bug-382986-lib.cs
1227 bug-382986-lib.dll: bug-382986-lib.cs
1228         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1229 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1230         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1231
1232 EXTRA_DIST += bug-17537-helper.cs
1233 bug-17537-helper.exe: bug-17537-helper.cs
1234         $(MCS) -out:$@ $(srcdir)/bug-17537-helper.cs
1235         chmod -x $@
1236
1237 bug-17537.exe: bug-17537.cs bug-17537-helper.exe
1238         $(MCS) -out:$@ $(srcdir)/bug-17537.cs
1239
1240 EXTRA_DIST += coreclr-security.cs
1241
1242 coreclr-security.exe : coreclr-security.cs
1243         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1244
1245 test-coreclr-security : coreclr-security.exe
1246         @echo "Testing coreclr-security.exe..."
1247         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1248
1249 EXTRA_DIST += generic-unboxing.2.il
1250 generic-unboxing.2.dll : generic-unboxing.2.il
1251         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1252
1253 EXTRA_DIST += generic-boxing.2.il
1254 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1255         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1256
1257 EXTRA_DIST += generic-unbox.2.cs
1258 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1259         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1260
1261 EXTRA_DIST += generic-box.2.cs
1262 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1263         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1264
1265 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1266 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1267         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1268 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1269         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1270
1271 bug-3903.exe: bug-3903.cs
1272         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1273
1274 gshared: test-generic-sharing
1275
1276 gshared-aot:
1277         @$(MAKE) AOT=1 gshared
1278
1279 GSHARED_TESTS = \
1280                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1281                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1282                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1283                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1284                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1285                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1286                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1287                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1288                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1289                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1290                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1291                 generic-array-exc.2.exe generic-special.2.exe                   \
1292                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1293                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1294                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1295                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1296                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1297                 generic-constrained.2.exe bug-431413.2.exe                      \
1298                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1299                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1300                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1301                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1302                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1303                 bug-479763.2.exe                                \
1304                 generic-type-load-exception.2.exe bug-616463.exe        \
1305                 bug-1147.exe
1306
1307 test-generic-sharing-normal: $(GSHARED_TESTS)
1308         @for fn in $+ ; do      \
1309                 echo "Testing $$fn ...";        \
1310                 $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;      \
1311                 $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;      \
1312                 $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;      \
1313                 $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;       \
1314                 if [ x$(AOT) = x1 ]; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1315         done
1316
1317 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1318         @$(RUNTIME) ./test-runner.exe -j a --testsuite-name "gshared" --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1319
1320 if NACL_CODEGEN
1321 test-generic-sharing:
1322 else
1323 test-generic-sharing:
1324         @if test x$(M) != x0; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1325 endif
1326
1327 EXTRA_DIST += async-exceptions.cs
1328 async-exceptions.exe : async-exceptions.cs
1329         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1330 test-async-exceptions : async-exceptions.exe
1331         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1332         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1333
1334 EXTRA_DIST += modules.cs modules-m1.cs
1335 modules-m1.netmodule: modules-m1.cs
1336         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1337 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1338         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1339
1340 # Useful if mono is compiled with --enable-shared=no
1341 patch-libtool:
1342         cp "../../libtool" .
1343         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1344         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1345         touch libtest.c
1346
1347
1348 if NACL_CODEGEN
1349 test-process-exit:
1350 else
1351 EXTRA_DIST += threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1352 test-process-exit:
1353         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1354         @echo "Testing threadpool-in-processexit.exe..."
1355         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1356         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1357 endif
1358
1359 OOM_TESTS =     \
1360         gc-oom-handling.exe     \
1361         gc-oom-handling2.exe
1362
1363
1364 test-oom: $(OOM_TESTS)
1365         @for fn in $+ ; do      \
1366                 echo "Testing $$fn ...";        \
1367                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1368                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1369         done
1370
1371 if HOST_WIN32
1372 test-unhandled-exception-2:
1373 else
1374 test-unhandled-exception-2: test-unhandled-exception-2-1 test-unhandled-exception-2-2 test-unhandled-exception-2-3 test-unhandled-exception-2-4 \
1375                  test-unhandled-exception-2-5 test-unhandled-exception-2-6 test-unhandled-exception-2-7 test-unhandled-exception-2-8
1376
1377 test-unhandled-exception-2-1: unhandled-exception-1.exe test-runner.exe
1378         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 1 $<
1379 test-unhandled-exception-2-2: unhandled-exception-2.exe test-runner.exe
1380         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1381 test-unhandled-exception-2-3: unhandled-exception-3.exe test-runner.exe
1382         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 255 $<
1383 test-unhandled-exception-2-4: unhandled-exception-4.exe test-runner.exe
1384         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1385 test-unhandled-exception-2-5: unhandled-exception-5.exe test-runner.exe
1386         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 255 $<
1387 test-unhandled-exception-2-6: unhandled-exception-6.exe test-runner.exe
1388         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1389 test-unhandled-exception-2-7: unhandled-exception-7.exe test-runner.exe
1390         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1391 test-unhandled-exception-2-8: unhandled-exception-8.exe test-runner.exe
1392         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 3 $<
1393 endif
1394
1395 EXTRA_DIST += appdomain-loader.cs appdomain-tester.cs
1396 test-appdomain-unload: appdomain-loader.exe appdomain-tester.exe
1397         $(RUNTIME) -O=gshared appdomain-loader.exe > appdomain-loader.exe.1.stdout || exit 1;
1398         $(RUNTIME) appdomain-loader.exe > appdomain-loader.exe.2.stdout || exit 1;
1399         MONO_DEBUG_ASSEMBLY_UNLOAD=1 $(RUNTIME) -O=gshared appdomain-loader.exe > appdomain-loader.exe.3.stdout || exit 1;
1400         MONO_DEBUG_ASSEMBLY_UNLOAD=1 $(RUNTIME) appdomain-loader.exe > appdomain-loader.exe.4.stdout || exit 1;
1401
1402 coreclr-gcstress:
1403         $(MAKE) -C $(mono_build_root)/acceptance-tests coreclr-gcstress
1404
1405 noinst_LTLIBRARIES = libtest.la
1406
1407 AM_CPPFLAGS = $(GLIB_CFLAGS)
1408
1409 if HOST_WIN32
1410 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1411 # This shows up when compiling mono_test_marshal_delegate ()
1412 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1413 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1414 # can't find them. So we use --kill-at to remove the @ suffix as well.
1415 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1416 else
1417 libtest_la_LDFLAGS = -rpath `pwd`
1418 endif
1419 libtest_la_SOURCES = libtest.c
1420 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1421
1422 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat